# Makefile to build libares.a
# Thomas Kuehne 2005-04-09

.PHONY: all install clean

DFLAGS=-release -O -inline -version=Posix
DMD=../../bin/dmd -I../dmdgc

SRC := $(filter-out sys/linux/c/linuxextern.d, $(wildcard std/*.d) $(wildcard std/c/*.d) $(wildcard sys/linux/c/*.d) )
OBJ := $(patsubst %.d,%.o,$(notdir $(SRC)))

all : libares.a

libares.a : $(SRC) linux.mak
	$(DMD) -c $(DFLAGS) $(SRC)
	$(RM) $@
	$(AR) -r $@ $(OBJ)

install : libares.a
	cp $< ../../lib/$<

clean :
	$(RM) libares.a $(OBJ)
