module object;

public import std.c.stddef;
public import std.c.stdbool;

class Object
{
    char[] toString();
    uint toHash();
    int opCmp(Object obj);
    int opEquals(Object obj);
}

struct Interface
{
    ClassInfo   classinfo;
    void*[]     vtbl;
    int         offset;		// offset to Interface 'this' from Object 'this'
}

class TypeInfo
{
    uint toHash();
    int opCmp(Object o);
    int opEquals(Object o);
    uint getHash(void *p);
    int equals(void *p1, void *p2);
    int compare(void *p1, void *p2);
    size_t tsize();
    void swap(void *p1, void *p2);
}

class ClassInfo : Object
{
    byte[]      init;		// class static initializer
    char[]      name;		// class name
    void*[]     vtbl;		// virtual function pointer table
    Interface[] interfaces;
    ClassInfo   base;
    void*       destructor;
    void(*classInvariant)(Object);
    uint        flags;
    // 1: // IUnknown
    void*       deallocator;
}

class Exception : Object
{
    char[]      msg;
    char[]      file;
    size_t      line;
    Exception   next;

    this(char[] msg, Exception next = null);
    this(char[] msg, char[] file, size_t line, Exception next = null);
    char[] toString();
}