/*
 * Written by Sean Kelly
 * Placed into Public Domain
 */

module std.c.posix.semaphore;

extern (C):

//
// Required
//
/*
sem_t

int sem_close(sem_t*);
int sem_destroy(sem_t*);
int sem_getvalue(sem_t*, int*);
int sem_init(sem_t*, int, uint);
sem_t* sem_open(char*, int, ...);
int sem_post(sem_t*);
int sem_trywait(sem_t*);
int sem_unlink(char*);
int sem_wait(sem_t*);
*/

version( linux )
{
    private struct _pthread_fastlock
    {
        int __status;
        int __spinlock;
    }

    struct sem_t
    {
        _pthread_fastlock   __sem_lock;
        int                 __sem_value;
        void*               __sem_waiting;
    }
}

int sem_close(sem_t*);
int sem_destroy(sem_t*);
int sem_getvalue(sem_t*, int*);
int sem_init(sem_t*, int, uint);
sem_t* sem_open(char*, int, ...);
int sem_post(sem_t*);
int sem_trywait(sem_t*);
int sem_unlink(char*);
int sem_wait(sem_t*);

//
// Timeouts (TMO)
//
/*
int sem_timedwait(sem_t*, timespec*);
*/