/*
 * Written by Sean Kelly
 * Placed into Public Domain
 */

module std.c.signal;

extern (C):

// this should be volatile
alias int sig_atomic_t;

private alias void function(int) sigfn_t;

version( Posix )
{
    const sigfn_t SIG_ERR = cast(sigfn_t) -1;
    const sigfn_t SIG_DFL = cast(sigfn_t) 0;
    const sigfn_t SIG_IGN = cast(sigfn_t) 1;

    // standard C signals
    const int SIGABRT = 6;  // Abnormal termination
    const int SIGFPE  = 8;  // Floating-point error
    const int SIGILL  = 4;  // Illegal hardware instruction
    const int SIGINT  = 2;  // Terminal interrupt character
    const int SIGSEGV = 11; // Invalid memory reference
    const int SIGTERM = 15; // Termination
}
else
{
    const sigfn_t SIG_ERR = cast(sigfn_t) -1;
    const sigfn_t SIG_DFL = cast(sigfn_t) 0;
    const sigfn_t SIG_IGN = cast(sigfn_t) 1;

    // standard C signals
    const int SIGABRT = 22; // Abnormal termination
    const int SIGFPE  = 8;  // Floating-point error
    const int SIGILL  = 4;  // Illegal hardware instruction
    const int SIGINT  = 2;  // Terminal interrupt character
    const int SIGSEGV = 11; // Invalid memory reference
    const int SIGTERM = 15; // Termination
}

sigfn_t signal(int sig, sigfn_t func);
int raise(int sig);