/*
 * Written by Sean Kelly
 * Placed into Public Domain
 */

module std.c.stdlib;

private import std.c.stddef;

extern (C):

struct div_t
{
    int quot,
        rem;
}

struct ldiv_t
{
    int quot,
        rem;
}

struct lldiv_t
{
    long quot,
         rem;
}

const int EXIT_SUCCESS = 0;
const int EXIT_FAILURE = 1;
const int RAND_MAX     = 32767;
const int MB_CUR_MAX   = 1;

double atof(char* nptr);
int atoi(char* nptr);
int atol(char* nptr);
long atoll(char* nptr);

double strtod(char* nptr, char** endptr);
float strtof(char* nptr, char** endptr);
real strtold(char* nptr, char** endptr);
int strtol(char* nptr, char** endptr, int base);
long strtoll(char* nptr, char** endptr, int base);
uint strtoul(char* nptr, char** endptr, int base);
ulong strtoull(char* nptr, char** endptr, int base);

double wcstod(wchar_t* nptr, wchar_t** endptr);
float wcstof(wchar_t* nptr, wchar_t** endptr);
real wcstold(wchar_t* nptr, wchar_t** endptr);
int wcstol(wchar_t* nptr, wchar_t** endptr, int base);
long wcstoll(wchar_t* nptr, wchar_t** endptr, int base);
ulong wcstoul(wchar_t* nptr, wchar_t** endptr, int base);
ulong wcstoull(wchar_t* nptr, wchar_t** endptr, int base);

int rand();
void srand(uint seed);
void* calloc(size_t nmemb, size_t size);
void free(void* ptr);
void* malloc(size_t size);
void* realloc(void* ptr, size_t size);
void abort();
int atexit(void function() func);
void exit(int status);
void _Exit(int status);
char*getenv(char* name);
int system(char* string);
void* bsearch(void* key, void* base, size_t nmemb, size_t size, int function(void*, void*) compar);
void qsort(void* base, size_t nmemb, size_t size, int function(void*, void*) compar);
int abs(int j);
int labs(int j);
long llabs(long j);
div_t div(int numer, int denom);
ldiv_t ldiv(int numer, int denom);
lldiv_t lldiv(long numer, long denom);
int mblen(char* s, size_t n);

int mbtowc(wchar_t* pwc, char* s, size_t n);
int wctomb(char*s, wchar_t wc);
size_t mbstowcs(wchar_t* pwcs, char* s, size_t n);
size_t wcstombs(char* s, wchar_t* pwcs, size_t n);

version( DigitalMars )
{
    void* alloca(uint size);
}