# Makefile to build libdmdrt.a
# Thomas Kuehne 2005-04-09

DFLAGS=-O -release -version=Posix
DMD=../../bin/dmd -I../ares

%.o : %.d
	$(DMD) -c $(DFLAGS) $<

%.o : typeinfo/%.d
	 $(DMD) -c $(DFLAGS) $<

SRC = $(filter-out testrt.d,$(wildcard typeinfo/*.d) $(wildcard *.d))

OBJS = $(patsubst %.d,%.o,$(notdir $(SRC)))

all : libdmdrt.a

libdmdrt.a : $(OBJS) linux.mak
	$(RM) $@
	$(AR) -r $@ $(OBJS)

install : libdmdrt.a
	cp $< ../../lib/$<

clean :
	$(RM) $(OBJS)
