
private import std.c.string;

// ubyte[]

class TypeInfo_Ah : TypeInfo
{
    char[] toString() { return "ubyte[]"; }

    uint getHash(void *p)
    {	ubyte[] s = *cast(ubyte[]*)p;
	uint len = s.length;
	ubyte *str = s;
	uint hash = 0;

	while (1)
	{
	    switch (len)
	    {
		case 0:
		    return hash;

		case 1:
		    hash *= 9;
		    hash += *cast(ubyte *)str;
		    return hash;

		case 2:
		    hash *= 9;
		    hash += *cast(ushort *)str;
		    return hash;

		case 3:
		    hash *= 9;
		    hash += (*cast(ushort *)str << 8) +
			    (cast(ubyte *)str)[2];
		    return hash;

		default:
		    hash *= 9;
		    hash += *cast(uint *)str;
		    str += 4;
		    len -= 4;
		    break;
	    }
	}

	return hash;
    }

    int equals(void *p1, void *p2)
    {
	ubyte[] s1 = *cast(ubyte[]*)p1;
	ubyte[] s2 = *cast(ubyte[]*)p2;

	return s1.length == s2.length &&
	       memcmp(cast(ubyte *)s1, cast(ubyte *)s2, s1.length) == 0;
    }

    int compare(void *p1, void *p2)
    {
    // NOTE: this is the code from phobos.std.string.cmp
	char[] s1 = *cast(char[]*)p1;
	char[] s2 = *cast(char[]*)p2;

    uint len = s1.length;
    int result;

    if (s2.length < len)
	len = s2.length;
    result = memcmp(s1, s2, len);
    if (result == 0)
	result = cast(int)s1.length - cast(int)s2.length;
    return result;
    }

    size_t tsize()
    {
	return (ubyte[]).sizeof;
    }
}

// void[]

class TypeInfo_Av : TypeInfo_Ah
{
    char[] toString() { return "void[]"; }
}
