/*
 *  Copyright (C) 2004 by Digital Mars, www.digitalmars.com
 *  Written by Walter Bright
 *
 *  This software is provided 'as-is', without any express or implied
 *  warranty. In no event will the authors be held liable for any damages
 *  arising from the use of this software.
 *
 *  Permission is granted to anyone to use this software for any purpose,
 *  including commercial applications, and to alter it and redistribute it
 *  freely, in both source and binary form, subject to the following
 *  restrictions:
 *
 *  o  The origin of this software must not be misrepresented; you must not
 *     claim that you wrote the original software. If you use this software
 *     in a product, an acknowledgment in the product documentation would be
 *     appreciated but is not required.
 *  o  Altered source versions must be plainly marked as such, and must not
 *     be misrepresented as being the original software.
 *  o  This notice may not be removed or altered from any source
 *     distribution.
 */

class TypeInfo_Delegate : TypeInfo
{
    char[] toString()
    {
	return next.toString() ~ " delegate()";
    }

    // BUG: need to add the rest of the functions

    size_t tsize()
    {	alias int delegate() dg;
	return dg.sizeof;
    }

    TypeInfo next;
}

class TypeInfo_D : TypeInfo
{
    private alias void delegate(int) dg;

    uint getHash(void *p)
    {	long l = *cast(long *)p;

	return cast(uint)(l + (l >> 32));
    }

    int equals(void *p1, void *p2)
    {
	return *cast(dg *)p1 == *cast(dg *)p2;
    }

    size_t tsize()
    {
	return dg.sizeof;
    }

    void swap(void *p1, void *p2)
    {
	dg t;

	t = *cast(dg *)p1;
	*cast(dg *)p1 = *cast(dg *)p2;
	*cast(dg *)p2 = t;
    }
}

